/* Tabela CODFISCOPER: Cdigo Fiscal de Operao */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela CODFISCOPER */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Cdigo Fiscal de Operao,
             utilizando a tabela Geral de Logs de Operaes */
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_FIS_CODFISCOPER' AND
                 TYPE   = 'TR'                  AND
	              U.UID  = O.UID                 AND
	              U.NAME = USER)
DROP TRIGGER LOG_FIS_CODFISCOPER
GO


CREATE TRIGGER LOG_FIS_CODFISCOPER
ON CODFISCOPER
FOR INSERT, UPDATE, DELETE
AS

   DECLARE  @V_USUARIO          VARCHAR(40);
   DECLARE  @V_TIPO             VARCHAR(1);
   DECLARE  @V_ITPESQ           VARCHAR(40);
   DECLARE  @V_DESC             VARCHAR(300);
   DECLARE  @V_DTOPER           DATETIME;
   DECLARE  @V_CDARVPROD_OLD    VARCHAR(20);
   DECLARE  @V_CDARVPROD_NEW    VARCHAR(20);


/*VARIVEIS DO CURSOR C_CURSORc*/

   DECLARE  @V_ID_COMANDO       VARCHAR(1);

   DECLARE  @V_NRINCIDCFOP_OLD  VARCHAR(10);
   DECLARE  @V_CDEMPRESA_OLD    VARCHAR(2);
   DECLARE  @V_IDENTSAICFOP_OLD VARCHAR(1);
   DECLARE  @V_CDTIPOOPER_OLD   VARCHAR(2);
   DECLARE  @V_CDINSCESTA_OLD   VARCHAR(16);
   DECLARE  @V_CDPRODUTO_OLD    VARCHAR(10);
   DECLARE  @V_CDFISCOPER_OLD   VARCHAR(10);
   DECLARE  @V_CDSUFXCFOP_OLD   VARCHAR(3);
   DECLARE  @V_CDGRUPOFISC_OLD  VARCHAR(3);
   DECLARE  @V_DTVALIDCFOP_OLD  DATETIME;
   DECLARE  @V_IDDIFEALIQ_OLD   VARCHAR(1);
   DECLARE  @V_CDMODDOCFISC_OLD VARCHAR(2);
   DECLARE  @V_IDCFOPINTEREST_OLD VARCHAR(1);
   DECLARE  @V_DSCDFISCOPER_OLD  VARCHAR(50);
   DECLARE  @V_IDDIFALIQCUSPR_OLD VARCHAR(1);

   DECLARE  @V_NRINCIDCFOP_NEW  VARCHAR(10);
   DECLARE  @V_CDEMPRESA_NEW    VARCHAR(2);
   DECLARE  @V_IDENTSAICFOP_NEW VARCHAR(1);
   DECLARE  @V_CDTIPOOPER_NEW   VARCHAR(2);
   DECLARE  @V_CDINSCESTA_NEW   VARCHAR(16);
   DECLARE  @V_CDPRODUTO_NEW    VARCHAR(10);
   DECLARE  @V_CDFISCOPER_NEW   VARCHAR(10);
   DECLARE  @V_CDSUFXCFOP_NEW   VARCHAR(3);
   DECLARE  @V_CDGRUPOFISC_NEW  VARCHAR(3);
   DECLARE  @V_DTVALIDCFOP_NEW  DATETIME;
   DECLARE  @V_IDDIFEALIQ_NEW   VARCHAR(1);
   DECLARE  @V_CDMODDOCFISC_NEW VARCHAR(2);
   DECLARE  @V_IDCFOPINTEREST_NEW VARCHAR(1);
   DECLARE  @V_DSCDFISCOPER_NEW  VARCHAR(50);
   DECLARE  @V_IDDIFALIQCUSPR_NEW VARCHAR(1);

BEGIN
   SET @V_TIPO = '0';
   SET @V_DESC = '';

   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSORc CURSOR FOR
   SELECT 'D'
      IDCOMANDO,
      NRINCIDCFOP,
      CDEMPRESA,
      IDENTSAICFOP,
      CDTIPOOPER,
      CDINSCESTA,
      CDPRODUTO,
      CDFISCOPER,
      CDSUFXCFOP,
      CDGRUPOFISC,
      DTVALIDCFOP,
      IDDIFEALIQ,
      CDMODDOCFISC,
      IDCFOPINTEREST,
      DSCDFISCOPER,
      IDDIFALIQCUSPR,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL

   FROM
      DELETED
   WHERE
      NRINCIDCFOP NOT IN (SELECT NRINCIDCFOP FROM INSERTED)
   UNION ALL

   SELECT 'U'
      IDCOMANDO,
      DELETED.NRINCIDCFOP,
      DELETED.CDEMPRESA,
      DELETED.IDENTSAICFOP,
      DELETED.CDTIPOOPER,
      DELETED.CDINSCESTA,
      DELETED.CDPRODUTO,
      DELETED.CDFISCOPER,
      DELETED.CDSUFXCFOP,
      DELETED.CDGRUPOFISC,
      DELETED.DTVALIDCFOP,
      DELETED.IDDIFEALIQ,
      DELETED.CDMODDOCFISC,
      DELETED.IDCFOPINTEREST,
      DELETED.DSCDFISCOPER,
      DELETED.IDDIFALIQCUSPR,
      INSERTED.NRINCIDCFOP,
      INSERTED.CDEMPRESA,
      INSERTED.IDENTSAICFOP,
      INSERTED.CDTIPOOPER,
      INSERTED.CDINSCESTA,
      INSERTED.CDPRODUTO,
      INSERTED.CDFISCOPER,
      INSERTED.CDSUFXCFOP,
      INSERTED.CDGRUPOFISC,
      INSERTED.DTVALIDCFOP,
      INSERTED.IDDIFEALIQ,
      INSERTED.CDMODDOCFISC,
      INSERTED.IDCFOPINTEREST,
      INSERTED.DSCDFISCOPER,
      INSERTED.IDDIFALIQCUSPR
   FROM
      INSERTED,
      DELETED
   WHERE
      INSERTED.NRINCIDCFOP = DELETED.NRINCIDCFOP
   UNION ALL

   SELECT 'I'
      IDCOMANDO,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NRINCIDCFOP,
      CDEMPRESA,
      IDENTSAICFOP,
      CDTIPOOPER,
      CDINSCESTA,
      CDPRODUTO,
      CDFISCOPER,
      CDSUFXCFOP,
      CDGRUPOFISC,
      DTVALIDCFOP,
      IDDIFEALIQ,
      CDMODDOCFISC,
      IDCFOPINTEREST,
      DSCDFISCOPER,
      IDDIFALIQCUSPR
   FROM
      INSERTED
   WHERE
      NRINCIDCFOP NOT IN (SELECT NRINCIDCFOP FROM DELETED);

   OPEN C_CURSORc;
   FETCH NEXT FROM C_CURSORc INTO @V_ID_COMANDO,
                                 @V_NRINCIDCFOP_OLD,
                                 @V_CDEMPRESA_OLD,
                                 @V_IDENTSAICFOP_OLD,
                                 @V_CDTIPOOPER_OLD,
                                 @V_CDINSCESTA_OLD,
                                 @V_CDPRODUTO_OLD,
                                 @V_CDFISCOPER_OLD,
                                 @V_CDSUFXCFOP_OLD,
                                 @V_CDGRUPOFISC_OLD,
                                 @V_DTVALIDCFOP_OLD,
                                 @V_IDDIFEALIQ_OLD,
                                 @V_CDMODDOCFISC_OLD,
                                 @V_IDCFOPINTEREST_OLD,
				 @V_DSCDFISCOPER_OLD,
				 @V_IDDIFALIQCUSPR_OLD,
                                 @V_NRINCIDCFOP_NEW,
                                 @V_CDEMPRESA_NEW,
                                 @V_IDENTSAICFOP_NEW,
                                 @V_CDTIPOOPER_NEW,
                                 @V_CDINSCESTA_NEW,
                                 @V_CDPRODUTO_NEW,
                                 @V_CDFISCOPER_NEW,
                                 @V_CDSUFXCFOP_NEW,
                                 @V_CDGRUPOFISC_NEW,
                                 @V_DTVALIDCFOP_NEW,
                                 @V_IDDIFEALIQ_NEW,
                                 @V_CDMODDOCFISC_NEW,
                                 @V_IDCFOPINTEREST_NEW,
				 @V_DSCDFISCOPER_NEW,
				 @V_IDDIFALIQCUSPR_NEW;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'D' BEGIN
         IF @V_CDEMPRESA_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Empr=' + @V_CDEMPRESA_OLD;
         END;
         IF @V_IDENTSAICFOP_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' EntrSaid=' + @V_IDENTSAICFOP_OLD;
         END;
         IF @V_CDTIPOOPER_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' TipoOper=' + @V_CDTIPOOPER_OLD;
         END;
         IF @V_CDINSCESTA_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' InscEsta=' + @V_CDINSCESTA_OLD;
         END;
         IF @V_CDPRODUTO_OLD IS NOT NULL BEGIN
            SELECT @V_CDARVPROD_OLD = CDARVPROD
            FROM PRODUTO
 	    WHERE CDPRODUTO = @V_CDPRODUTO_OLD;
	    IF @V_CDARVPROD_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Prod=' + @V_CDARVPROD_OLD;
            END;
         END;
         IF @V_CDFISCOPER_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CFOp=' + @V_CDFISCOPER_OLD;
         END;
         IF @V_CDSUFXCFOP_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' SufxCFOp=' + @V_CDSUFXCFOP_OLD;
         END;
         IF @V_CDGRUPOFISC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' GrupFisc=' + @V_CDGRUPOFISC_OLD;
         END;
         IF @V_DTVALIDCFOP_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DtIniVal=' + CONVERT(VARCHAR,@V_DTVALIDCFOP_OLD);
         END;
         IF @V_IDDIFEALIQ_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DifeAliq=' + @V_IDDIFEALIQ_OLD;
 	    IF @V_IDDIFALIQCUSPR_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' DifeAliqPrd=' + @V_IDDIFALIQCUSPR_OLD;
	    END;
         END;
         IF @V_CDMODDOCFISC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' ModDocFis=' + @V_CDMODDOCFISC_OLD;
         END;
         IF @V_IDCFOPINTEREST_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' OperInter=' + @V_IDCFOPINTEREST_OLD;
         END;
         IF @V_DSCDFISCOPER_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Desc=' + @V_DSCDFISCOPER_OLD;
         END;
         SET @V_TIPO = '3';
         SET @V_ITPESQ = @V_NRINCIDCFOP_OLD;
      END
      ELSE BEGIN
         IF @V_ID_COMANDO= 'U' /*UPDATING*/ BEGIN
            IF (@V_CDEMPRESA_NEW    <> @V_CDEMPRESA_OLD)    OR
               (@V_IDENTSAICFOP_NEW <> @V_IDENTSAICFOP_OLD) OR
               (@V_CDTIPOOPER_NEW   <> @V_CDTIPOOPER_OLD)   OR
               (@V_CDINSCESTA_NEW   <> @V_CDINSCESTA_OLD)   OR
               (@V_CDFISCOPER_NEW   <> @V_CDFISCOPER_OLD)   OR
               (@V_DTVALIDCFOP_NEW  <> @V_DTVALIDCFOP_OLD)  OR
               (@V_IDDIFEALIQ_NEW   <> @V_IDDIFEALIQ_OLD)   OR
	       (@V_DSCDFISCOPER_NEW <> @V_DSCDFISCOPER_OLD) OR
               (@V_IDDIFALIQCUSPR_NEW <> @V_IDDIFALIQCUSPR_OLD) OR
               (ISNULL(@V_CDPRODUTO_NEW, '!')    <> ISNULL(@V_CDPRODUTO_OLD, '!'))   OR
               (ISNULL(@V_CDSUFXCFOP_NEW, '!')   <> ISNULL(@V_CDSUFXCFOP_OLD, '!'))  OR
               (ISNULL(@V_CDGRUPOFISC_NEW, '!')  <> ISNULL(@V_CDGRUPOFISC_OLD, '!')) OR
               (ISNULL(@V_CDMODDOCFISC_NEW, '!') <> ISNULL(@V_CDMODDOCFISC_OLD, '!'))OR
               (ISNULL(@V_IDCFOPINTEREST_NEW, '!') <> ISNULL(@V_IDCFOPINTEREST_OLD, '!'))BEGIN
               SET @V_TIPO   = '2';
               SET @V_ITPESQ = @V_NRINCIDCFOP_OLD;
            END;
         END
         ELSE  BEGIN
            SET @V_TIPO   = '1';
            SET @V_ITPESQ = @V_NRINCIDCFOP_NEW;
         END;
      END;
      SELECT @V_CDARVPROD_NEW = CDARVPROD 
      FROM PRODUTO
      WHERE CDPRODUTO = @V_CDPRODUTO_NEW;

      IF @V_CDEMPRESA_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + 'Empr=' + @V_CDEMPRESA_NEW;
      END;

      IF @V_IDENTSAICFOP_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' EntrSaid=' + @V_IDENTSAICFOP_NEW;
      END;

      IF @V_CDTIPOOPER_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' TipoOper=' + @V_CDTIPOOPER_NEW;
      END;

      IF @V_CDINSCESTA_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' InscEsta=' + @V_CDINSCESTA_NEW;
      END;

      IF @V_CDARVPROD_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' Prod=' + @V_CDARVPROD_NEW;
      END;

      IF @V_CDFISCOPER_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' CFOp=' + @V_CDFISCOPER_NEW;
      END;

      IF @V_CDSUFXCFOP_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' SufxCFOp=' + @V_CDSUFXCFOP_NEW;
      END;

      IF @V_CDGRUPOFISC_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' GrupFisc=' + @V_CDGRUPOFISC_NEW;
      END;

      IF @V_DTVALIDCFOP_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' DtIniVal=' + CONVERT(VARCHAR,@V_DTVALIDCFOP_NEW);
      END;

      IF @V_IDDIFEALIQ_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' DifeAliq=' + @V_IDDIFEALIQ_NEW;
	 IF @V_IDDIFALIQCUSPR_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DifeAliqPrd=' + @V_IDDIFALIQCUSPR_NEW;
	 END;      
      END;

      IF @V_CDMODDOCFISC_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' ModDocFis=' + @V_CDMODDOCFISC_NEW;
      END;

      IF @V_IDCFOPINTEREST_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' OperInter=' + @V_IDCFOPINTEREST_NEW;
      END;
      IF @V_DSCDFISCOPER_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' Desc=' + @V_DSCDFISCOPER_NEW;
      END;

      IF @V_TIPO <> '0' BEGIN
         EXEC NMUSUARIO @V_USUARIO;
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();

               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER,
                   IDTIPOOPER, CDPESQITEM, DSOPERACAO)
               VALUES
                  ('CODFISCOPER',  @V_DTOPER, @V_USUARIO,
                   @V_TIPO,      @V_ITPESQ, @V_DESC);
            END;
         END;
      END;

   FETCH NEXT FROM C_CURSORc INTO @V_ID_COMANDO,
                                 @V_NRINCIDCFOP_OLD,
                                 @V_CDEMPRESA_OLD,
                                 @V_IDENTSAICFOP_OLD,
                                 @V_CDTIPOOPER_OLD,
                                 @V_CDINSCESTA_OLD,
                                 @V_CDPRODUTO_OLD,
                                 @V_CDFISCOPER_OLD,
                                 @V_CDSUFXCFOP_OLD,
                                 @V_CDGRUPOFISC_OLD,
                                 @V_DTVALIDCFOP_OLD,
                                 @V_IDDIFEALIQ_OLD,
                                 @V_CDMODDOCFISC_OLD,
                                 @V_IDCFOPINTEREST_OLD,
                                 @V_DSCDFISCOPER_OLD,
				 @V_IDDIFALIQCUSPR_OLD,
                                 @V_NRINCIDCFOP_NEW,
                                 @V_CDEMPRESA_NEW,
                                 @V_IDENTSAICFOP_NEW,
                                 @V_CDTIPOOPER_NEW,
                                 @V_CDINSCESTA_NEW,
                                 @V_CDPRODUTO_NEW,
                                 @V_CDFISCOPER_NEW,
                                 @V_CDSUFXCFOP_NEW,
                                 @V_CDGRUPOFISC_NEW,
                                 @V_DTVALIDCFOP_NEW,
                                 @V_IDDIFEALIQ_NEW,
                                 @V_CDMODDOCFISC_NEW,
                                 @V_IDCFOPINTEREST_NEW,
				 @V_DSCDFISCOPER_NEW,
			  	 @V_IDDIFALIQCUSPR_NEW;

   END;
   CLOSE      C_CURSORc;
   DEALLOCATE C_CURSORc;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_FIS_CODFISCOPER','5.25.000';
GO



